import java.util.*;

public class EX1 {

/**
 * EX1: Scrivere un metodo per verificare se due liste concatenate
 * semplici hanno lo stesso contenuto (nello stesso ordine)
 */


  public static boolean compareLists(LinkedList l1, LinkedList l2){

   if (l1.isEmpty() && l2.isEmpty()) return true;
   if (l1.isEmpty() || l2.isEmpty()) return false;

   ListNode pl1=l1.getHead();
   ListNode pl2=l2.getHead();

   while(pl1!= null && pl2!= null){
       //Confronto dei corrispondenti elementi
       if( ((Comparable)pl1.getInfo()).compareTo(pl2.getInfo())!= 0)
         return false;
       else
       {//Spostamento dei puntatori ai successivi elementi della lista
         pl1=pl1.getNext();
         pl2=pl2.getNext();
       }
   }

   if (pl1== null && pl2== null)
     return true;
   else return false;

  }



  /*** esercizio utile a scopo didattico per comprendere la ricorsione ***/
  public static boolean compareListsRec(LinkedList l1, LinkedList l2){
   // condizioni di terminazione	
   if (l1.isEmpty() && l2.isEmpty()) return true;
   if (l1.isEmpty() || l2.isEmpty()) return false;
   // passo ricorsivo
   ListNode pl1=l1.getHead();
   ListNode pl2=l2.getHead();	
   if ( ((Comparable)pl1.getInfo()).compareTo(pl2.getInfo())!= 0 )
	return false;
   else {
	Object info1=l1.deleteHead(), info2=l2.deleteHead();
	boolean risposta = compareListsRec(l1,l2); // confronta le liste private del primo elemento
	l1.insertHead(info1);
	l2.insertHead(info2);
	return risposta;
   }

  }



  public static void main (String[ ] args) {
     new EX1().run();
  } // method main

  public void run(){

     	/**** GENERAZIONE LISTE CASUALI UGUALI ****/	
     	final int SEED = 111; // seme della sequenza
     	// Random r = new Random (SEED);
     	Random r = new Random ();

     	LinkedList  randList1, randList2;
	randList1 = new LinkedList( );
	randList2 = new LinkedList( );
     	// generazione di due liste uguali randList1 e randList2 di 10 interi casuali nel range 0...99:
     	for (int i = 0; i < 10; i++){ 
	     int randVal = r.nextInt(100);
             randList1.insertHead (new MyInteger(randVal));
             randList2.insertHead (new MyInteger(randVal));
	}
	//ESITO TRUE
	String risp;
	System.out.println("\nEX1 - Confronto tra:");
        randList1.printList( );
        randList2.printList( );
    	risp= compareListsRec(randList1,randList2)? "Le liste sono uguali" : "Le liste non sono uguali";
    	System.out.println(risp);
	//ESITO FALSE
	randList1.deleteHead();
	randList1.insertHead (new MyInteger(r.nextInt(100)));
	System.out.println("EX1 - Confronto tra:");
        randList1.printList( );
        randList2.printList( );
    	risp= compareListsRec(randList1,randList2)? "Le liste sono uguali" : "Le liste non sono uguali";
    	System.out.println(risp);
      
 } // method run

} // class EX1
