import java.util.*;


/**
 * Esercizio n.4: Fondere due liste semplicemente concatenate ordinate di interi
 * in una lista semplicemente concatenata ordinata di interi.
 */


public class EX4 {


 public static LinkedList mergeList(LinkedList l1, LinkedList l2)
 {
    LinkedList l3 = new LinkedList();
    ListNode p1 = l1.getHead();
    ListNode p2 = l2.getHead();

    while(p1!= null && p2!= null)
    {
      int temp = ((Comparable) p1.getInfo()).compareTo(p2.getInfo());
      if (temp <= 0 )
       {  //l'elemento corrente di l1  <= a quello di l2
          l3.insertTail(p1.getInfo());
          p1 = p1.getNext();
       }
      else
      {  //l'elemento corrente di l1  > a quello di l2
          l3.insertTail(p2.getInfo());
          p2 = p2.getNext();
       }
     }//End while

     //Attacchiamo l'eventuale coda della lista piu' lunga
     while(p1!= null)
     {// l1 e' la lista piu' lunga

        l3.insertTail(p1.getInfo());
        p1 = p1.getNext();
     }

    while(p2!= null)
     {// l2 e' la lista piu' lunga

        l3.insertTail(p2.getInfo());
        p2 = p2.getNext();
     }

    return l3;
  }


  public static void main (String[ ] args) {
     new EX4().run();
  } // method main

  public void run(){

     	/**** GENERAZIONE LISTE CASUALI ORDINATE ****/	
     	final int SEED = 111; // seme della sequenza
     	// Random r = new Random (SEED);
     	Random r = new Random ();

     	LinkedList  randList1, randList2, mList;
	randList1 = new LinkedList( );
	randList2 = new LinkedList( );
     	// generazione di due liste ordinate di 10 interi casuali nel range 0...99:
     	for (int i = 0; i < 10; i++)
             randList1.insertOrd (new MyInteger(r.nextInt(100)));
     	for (int i = 0; i < 10; i++){ 
             randList2.insertOrd (new MyInteger(r.nextInt(100)));
	}
	System.out.println("Liste da concatenare:");
        randList1.printList( );
        randList2.printList( );
	
	mList = mergeList(randList1, randList2);
	System.out.println("Lista concatenata:");
        mList.printList( );
      
 } // method run

} // class EX4
